/*
	LUSScreenSaver Plugin LUSSSUniverse ( into Universe image )
	Copyright (C) 2003 ONO,Masayuki.<mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSSSUniverse.h"

#include <qtextcodec.h>
#define _T(str) QTextCodec::codecForLocale()->toUnicode(str)

LUSSSUniverse::LUSSSUniverse()
: m_pWidget(0), ref(0)
{
}

LUSSSUniverse::~LUSSSUniverse(  )
{
}

QString LUSSSUniverse::Name()
{
	return _T( "" );
}

QString LUSSSUniverse::Version()
{
	return _T( "1.0.0" );
}

QString LUSSSUniverse::Comment()
{
	return _T( "Ϥޤ" );
}

void LUSSSUniverse::Setting()
{
//	LUSSSTemplateSetting dlg( NULL, _T("ɽ"), TRUE, 0 );
//	dlg.exec();
}

QWidget* LUSSSUniverse::Init( int nMode )
{
	switch( nMode )
	{
	case LUS_NORMAL:
		{
			m_pWidget = new LUSSSUniverseWidget( NULL );
			m_pWidget->setEllipseSize( 3 );
		}
		break;
	case LUS_PREVIEW:
		{
			m_pWidget = new LUSSSUniverseWidget( NULL );
			m_pWidget->setEllipseSize( 1 );
		}
		break;
	default:
		{
			m_pWidget = NULL;
		}
		break;
	}
	
	return (QWidget*)m_pWidget;
}

void LUSSSUniverse::Start()
{
	if ( m_pWidget )
	{
		m_pWidget->Start();
	}
}

void LUSSSUniverse::Stop()
{
	if ( m_pWidget )
	{
		m_pWidget->Stop();
		delete m_pWidget;
	}
}

QRESULT LUSSSUniverse::queryInterface(const QUuid& uuid,
	QUnknownInterface** iface)
{
	*iface = 0;
	if(uuid == IID_QUnknown)
	{
		*iface = this;
	}
	else if ( uuid == IID_LUSScreenSaver )
	{
		*iface = this;
	}

	if(*iface)
	{
		(*iface)->addRef();
	}

	return QS_OK;
}

Q_EXPORT_INTERFACE()
{
	Q_CREATE_INSTANCE( LUSSSUniverse )
}
