/*
	LUSScreenSaver Plugin LUSSSUniverse ( into Universe image )
	Copyright (C) 2003 ONO,Masayuki.<mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSSSUniverseWidget.h"

LUSSSUniverseWidget::LUSSSUniverseWidget( QWidget* parent, const char* name )
	: QWidget( parent, name, WDestructiveClose ), m_nEllipseSize( 3 )
{
	clearWFlags( WStyle_Title );
}

LUSSSUniverseWidget::~LUSSSUniverseWidget(  )
{
}

void LUSSSUniverseWidget::setEllipseSize( int size )
{
	m_nEllipseSize = size;
}

void LUSSSUniverseWidget::Start()
{
	setBackgroundColor( QColor( 0, 0, 0 ) );
	erase();

	show();

	for ( int nCnt = 0; nCnt < 50; nCnt++ )
	{
		star[ nCnt ].point = QPoint( rand() / ( RAND_MAX / ( width() + 1 ) ),
									rand() / ( RAND_MAX / ( height() + 1 ) ) );
		star[ nCnt ].size = m_nEllipseSize;
	}

	repaint( TRUE );

	timer = new QTimer(this);
	connect( timer, SIGNAL( timeout() ), this, SLOT( timerDo() ) );
	timer->start( 70, false );
}

void LUSSSUniverseWidget::Stop()
{
	if ( !timer )
	{
		timer->stop();
		delete timer;
	}
}

void LUSSSUniverseWidget::timerDo()
{
	erase();
	QPainter painter;
	painter.begin( this );
	for ( int nCnt = 0; nCnt < 50; nCnt++ )
	{	
		QPoint offset;
		if ( star[ nCnt ].point.x() < width() / 2 
			&& star[ nCnt ].point.y() < height() / 2)
		{
			offset = QPoint( -1, -1 );
		}
		else
		if ( star[ nCnt ].point.x() > width() / 2 
			&& star[ nCnt ].point.y() < height() / 2)
		{
			offset = QPoint( 1, -1 );
		}
		else
		if ( star[ nCnt ].point.x() < width() / 2 
			&& star[ nCnt ].point.y() > height() / 2)
		{
			offset = QPoint( -1, 1 );
		}
		else
		{
			offset = QPoint( 1, 1 );
		}

		star[ nCnt ].point += offset;

		if ( star[ nCnt ].point.x() < 0 || star[ nCnt ].point.x() > width()
			|| star[ nCnt ].point.y() < 0 || star[ nCnt ].point.y() > height() )
		{
			star[ nCnt ].point = QPoint( rand() / ( RAND_MAX / ( width() + 1 ) ),
										rand() / ( RAND_MAX / ( height() + 1 ) ) );
			if ( rand() / ( RAND_MAX / ( 3 + 1 ) ) == 3 )
			{
				star[ nCnt ].size = m_nEllipseSize + 1;
			}
			else
			{
				star[ nCnt ].size = m_nEllipseSize;
			}
		}

		painter.setPen( QColor(255,255,255) );
		painter.drawEllipse( star[ nCnt ].point.x(), star[ nCnt ].point.y()
							, star[ nCnt ].size, star[ nCnt ].size );
	}
	painter.end();
}

void LUSSSUniverseWidget::paintEvent( QPaintEvent * )
{
}

